module ReduxGen
  class Template
    attr_accessor :name

    def initialize(component, name, test: false)
      @renderer = Template.renderer_for component, test: test
      @name = Validations.sanitize component, name
    end

    def render
      @renderer.result(binding)
    end

    def self.template_directory
      File.expand_path("../../../template", __FILE__)
    end

    def self.path component
      "#{template_directory}/#{component}.js.erb"
    end

    def self.test_path component
      "#{template_directory}/#{component}.spec.js.erb"
    end

    def self.renderer_for component, test: false
      path = test ? Template.test_path(component) : Template.path(component)
      ERB.new(open(path).read)
    end
  end
end
